<?php

if (!class_exists('HTMLTableBuf')) {

define('SLTABLE_IMG_CHECK', '<img src="typo3conf/ext/eticket/pi1/img/tick.gif">');
define('SLTABLE_IMG_CROSS', '<img src="typo3conf/ext/eticket/pi1/img/cross.gif">');

require_once('class.HTMLTableBuf.php');

class slTable {
	var $ID = NULL;
	var $data = NULL;
	var $dataClass = NULL;
	var $iRow = -1;
	var $iCol = 0;
	var $thes = array();
	var $more = 'class="nospacing"';
	var $generation = '';
	var $sortable = FALSE;
	var $sortLinkPrefix = '';
	var $dataPlus = ''; // the first row after the header - used for filters
	var $prefix = 'slTable';
	var $sortBy, $sortOrder;
	var $footer;		// last line
	var $isAlternatingColumns = FALSE;
	var $isOddEven = TRUE;
	var $thesMore;		// string?
	var $thesPerform = TRUE;
	var $clickOnRow;

	function slTable($id = NULL, $more="") {
		if (is_array($id)) {
			$this->data = $id;
		//	return $this->getContent();
		}
		if (!$id) $id = md5(time());
		$this->ID = $id;
		$this->more = $more ? $more : $this->more;
	}

	function thes($aThes, $thesMore = NULL) {
		$this->thes = $aThes;
		if ($thesMore !== NULL) {
			$this->thesMore = $thesMore;
		}
	}

	function addRow() {
		$this->iRow++;
		$this->iCol = 0;
	}

	function addRowData($row) {
		$this->data[] = $row;
		$this->iRow++;
		$this->iCol = 0;
	}

	function add($val) {
		$this->data[$this->iRow][$this->iCol] = $val;
		$this->iCol++;
	}

	function addVal($col, $val) {
		$this->data[$this->iRow][$col] = $val;
		$this->iCol++;
	}

	/**
	 * To sort, $this->thes with all datatypes should be known
	 */
	function tabSortByUrl($a, $b) {
		$by = $this->sortBy;
		$so = $this->sortOrder;
		$aa = $a[$by];
		$bb = $b[$by];

		// get $aa && $bb
		if ($this->thes[$by]['type'] == 'date') {
			$aa = strtotime2($aa);
			$bb = strtotime2($bb);
		} else if ($this->thes[$by]['type'] == 'int') {
			$aa = intval(strip_tags($aa));
			$bb = intval(strip_tags($bb));
		} else {
			// otherwise it's a string
			$aa = strip_tags($aa);
			$bb = strip_tags($bb);
			if (!$so) {
				return strcmp($aa, $bb);
			} else {
				return strcmp($bb, $aa);
			}
		}

		//debug($by, $so, $aa, $bb);
		// $aa && $bb are known
		if ($aa == $bb) {
			return 0;
		} else {
			if (!$so) {
				return $aa > $bb ? +1 : -1;
			} else {
				return $aa < $bb ? +1 : -1;
			}
		}
	}

	function setSortBy($by = NULL, $or = NULL) {
		if ($by === NULL && $or === NULL) {
			$by = $_REQUEST['slTable']['sortBy'];
			$or = $_REQUEST['slTable']['sortOrder'];
		}
		// sortBy for th linking and sorting below
		$this->sortBy = $by;
		$this->sortOrder = $or;
		if (!$this->sortBy) {
			reset($this->thes);
			//debug($this->thes);
			list($this->sortBy) = current($this->thes);
			//$this->sortBy = 'l3';
		}
	}

	function sort() {
		// sorting
		//debug('$this->sortBy', $this->sortBy);
		if ($this->sortable && $this->sortBy) {
			//print view_table($this->data);
			uasort($this->data, array($this, 'tabSortByUrl')); // $this->sortBy is used inside
			//print view_table($this->data);
			//debug($this->thes[$this->sortBy]);
			if (is_array($this->thes[$this->sortBy])) {
				$th = &$this->thes[$this->sortBy]['name'];
			} else {
				$th = &$this->thes[$this->sortBy];
			}
			if ($this->sortOrder) {
				$th .= '<img src="skin/default/img/down.gif" align="absmiddle">';
			} else {
				$th .= '<img src="skin/default/img/up.gif" align="absmiddle">';
			}
			//debug($this->thes[$this->sortBy]);
		}
	}

	function generate($width = array()) {
		global $db;

		if (!$this->generation) {
			if (!sizeof($this->thes) && sizeof($this->data) && $this->data != FALSE) {
				$thes = array();
				foreach ($this->data as $current) {
					$thes = array_merge($thes, array_keys($current));
				}
				$thes = array_unique($thes);
				$thes = array_combine($thes, $thes);
				unset($thes['###TD_CLASS###']);
				$this->thes($thes);
				$this->isOddEven = TRUE;
				//$this->thesMore = 'style="background-color: #5cacee; color: white;"';
				if (!$this->more) {
					$this->more = 'class="nospacing"';
				}
			}

			if ($this->sortable) {
				$this->sort();
			}

			$t = new htmlTableBuf();
			//table
			$t->table((is_string($this->more) ? $this->more : $this->more['tableMore']) . ' id="'.$this->ID.'"');

			//th
			$thes = $this->thes; //array_filter($this->thes, array($this, "noid"));
			$thes2 = array();
			$thmore = array();
			foreach ($thes as $thk => $thv) {
				if (is_array($thv)) {
					$thvName = $thv['name'] ? $thv['name'] : $thv['label'];
					$thmore[$thk] = $thv['thmore'];
				} else {
					$thvName = $thv;
				}
				if ($this->sortable) {
					//debug($_REQUEST[$this->prefix]['sortBy'], $thk);
					if ($this->sortBy == $thk) {
						$newSO = !$this->sortOrder;
					} else {
						$newSO = $this->sortOrder;
					}
					$link = ($this->sortLinkPrefix ? $this->sortLinkPrefix . '&' : $_SERVER['PHP_SELF'].'?').$this->prefix.'[sortBy]='.$thk.'&'.$this->prefix.'[sortOrder]='.$newSO;
					$thes2[$thk] = str::ahref($thvName, $link, FALSE);
				} else {
					$thes2[$thk] = $thvName;
				}
				if (is_array($thv) && $thv['new_tr']) {
					unset($thes2[$thk]);
				}
			}

			//debug($thes, $this->sortable);
			if ($this->thesPerform) $t->thes($thes2, $thmore, $this->thesMore . (is_array($this->more) ? $this->more['thesMore'] : '')); // $t is not $this // sorting must be done before

			// col
			if ($this->isAlternatingColumns) {
				for ($i = 0; $i < sizeof($this->thes); $i++) {
					$t->stdout .= '<col class="'.($i%2?'even':'odd').'">';
				}
			}

			if ($this->dataPlus) {
				$this->data = array_merge(array($this->dataPlus), $this->data);
			}

			// td
			if (!is_array($this->data)) {
				$data = array();
			} else {
				$data = $this->data;
			}
			$i = -1;
			foreach ($data as $key => $row) { // (almost $this->data)
				$tr = $this->getTRClass($row, $key);
				$t->tr($tr);
				$this->genRow($t, $row, $key);
				$t->tre();
			}
			if ($this->footer) {
				$class = array();
				if ($this->isOddEven) {
					$class[] = (++$i%2?'even':'odd');
				}
				$class[] = 'footer';
				$tr = 'class="'.implode(' ', $class).'"';
				$t->tr($tr);
				$this->genRow($t, $this->footer, $key+1);
				$t->tre();
			}
			$t->tablee();
			$this->generation = $t;
		}
	}

	function getTRClass($row, $key) {
		$class = array();
		if ($row['###TD_CLASS###']) {
			$class[] = $row['###TD_CLASS###'];
		}
		if ($this->isOddEven) {
			$class[] = ($this->lineCounter%2?'even':'odd');
			$this->lineCounter++;
		}
		//debugster(array($key, $this->dataClass));
		if ($this->dataClass[$key]) {
			$class[] = $this->dataClass[$key];
		}
		$tr = 'class="'.implode(' ', $class).'"';
		$tr .= $this->trmore;
		return $tr;
	}

	function genRow($t, $row, $rowNr) {
		/* @var $t HTMLTableBuf */
		$skipCols = 0;
		foreach ($this->thes as $col => $k) {
			if ($skipCols) {
				$skipCols--;
			} else if (!is_array($k) xor (is_array($k) && !$k['!show'])) {
				$val = $row[$col];
				if (!$val) {
					$val = $row[strtolower($col)];
				}

				//$out = $this->getCell($col, $val, $k);
				if ($val instanceof slTableValue) {
					$out = $val->render();
				} else {
					//$stv = new slTableValue($val, $k);
					if ($this->caller) {
						$stv = $this->caller->makeInstance('slTableValue', $val, $k);
					} else {
						$stv = new slTableValue($val, $k);
					}
					$out = $stv->render();
				}

				//$more .= ($this->isAlternatingColumns ? 'class="'.($iCol%2?'even':'odd').'"' : '');
				if (is_array($row[$col.'.'])) {
					$more .= $row[$col.'.']['colspan'] ? ' colspan="'.$row[$col.'.']['colspan'].'"' : '';
					$skipCols = $row[$col.'.']['colspan'] ? $row[$col.'.']['colspan'] - 1 : 0;
				}
				if ($this->clickOnRow[$rowNr]) {
					$out = str_replace('###CELL###', $out ? $out : '&nbsp;', $this->clickOnRow[$rowNr]);
				}
				$tdParams = is_array($k) ? $k['more'] : '';
				if (is_array($k) && $k['colspan']) {
					$tdParams .= ' colspan="'.$k['colspan'].'"';
				}
				$t->cell($out, $width[$iCol++], $tdParams);
				if (is_array($k) && $k['new_tr']) {
					$t->tre();
					$tr = $this->getTRClass($row, $rowNr);
					$t->tr($tr);
				}
				$iCol++;
			} else {
				$t->cell('slTable ?else?');
			}
		}
	}

	function show() {
		if (!$this->generation) {
			$this->generate();
		}
		$this->generation->render();
	}

	function render() {
		$this->show();
	}

	function getContent() {
		if (!$this->generation) {
			$this->generate();
		}
		return $this->generation->getContent();
	}

	function getData($table) {
		$cols = $GLOBALS['db']->getTableColumns($table);
		$data = $GLOBALS['db']->getTableDataEx($table, "deleted = 0");
		for ($i = 0; $i < sizeof($data); $i++) {
			$this->addRow();
			$iCol = 0;
			foreach ($data[$i] as $val) {
				$this->addVal($cols[$iCol++], $val);
			}
		}
	}

	function addRowWithMore($row) {
		$this->addRow();
		foreach ($row as $col => $val) {
			$this->addVal($col, $val);
		}
	}

	function getTotals($cols = array()) {
		$totals = array();
		foreach ($this->data as $row) {
			foreach ($cols as $col) {
				$totals[$col] += $row[$col];
			}
		}
		return $totals;
	}

};

class slTableValue {
	var $value = NULL;
	var $desc = array(
//		'hsc' => TRUE,
	);

	function __construct($value, $desc = array()) {
		if ($value instanceof slTableValue) {
			$value = $value->value;
			//debugster(array($value, $value->desc, '+', $desc, '=', (array)$value->desc + $desc));
			$desc = (array)$value->desc + $desc; // overwriting in a correct way
		}
		$this->value = $value;
		$this->desc += (array)$desc;
	}

/*	function render() {
		$value = $this->value;
		if (is_array($value)) {
			$value = t3lib_div::view_array($value);
		} else {
			if ($this->desc['hsc']) {
				$value = htmlspecialchars($value);
			}
		}
		return $value.' ('.$this->desc['type'].')';
	}
*/

	function render() {
		$content = $this->getCell('?getCell?', $this->value, $this->desc);
		return $content;
	}

	function getCell($col, $val, $k) {
		switch ($k['type']) {
			case "select":
			case 'ajaxSingleChoice':
			case "selection":
				//t3lib_div::debug($val);
				//t3lib_div::debug($k);
				if ($val) {
					$what = $k['title'] ? $k['title'] : $col;
					$out = $GLOBALS['db']->sqlFind($what, $k['from'], "uid = '".$val."'", FALSE);
				} else {
					$out = "";
				}
			break;
			case "date":
				if ($val) {
					$out = date($k['format'] ? $k['format'] : 'Y-m-d H:i:s', $val);
				} else {
					$out = '';
				}
			break;
			case "sqldate":
				if ($val) {
					$val = strtotime($val);
					$out = date($k['format'], $val);
				} else {
					$out = '';
				}
			break;
			case "file":
				$out = str::ahref($val, $GLOBALS['uploadURL'].$val, FALSE);
			break;
			case "money":
				$out = number_format($val, 2, '.', '') . "&nbsp;&euro;";
			break;
			case "delete":
				$out = str::ahref("Del", "?perform[do]=delete&perform[table]={$this->ID}&perform[id]=".$row['id'], FALSE);
			break;
			case "datatable":
				//$out .= t3lib_div::view_array(array('col' => $col, 'val' => $val, 'desc' => $k));
				$out .= $k['prefix'];
				$f = $this->caller->makeInstance('HTMLForm');
				$f->prefix($this->prefixId);
				$out .= $f->datatable($col, $val, $k, $details = TRUE, $doDiv = TRUE, 'sltable', $data = 'test');
				$out .= $k['append'];
			break;
			case 'link':
				$out = '<a href="'.$val.'" target="'.$k['target'].'">'.($k['text'] ? $k['text'] : $val).'</a>';
			break;
			case 'image':
				$out = '<img src="'.$k['prefix'].$val.'" />';
			break;
			case "checkbox":
				if ($val) {
					$img = SLTABLE_IMG_CHECK;
				} else {
					$img = SLTABLE_IMG_CROSS;
				}
				if ($k['link']) {
					$out = '<a href="'.$k['link'].'">'.$img.'</a>';
				} else {
					$out = $img;
				}
			break;
			case "percent":
				$out = number_format($val*100, 2, '.', '').'&nbsp;%';
			break;
			case "textarea":
				$val = nl2br($val);
			//break; // FALL DOWN!
			default:
				//if (intval($val) == 129) {debugster($val);}
				if ($val instanceof slTableValue) {
					$out = $val->render();
				} else {
					$out = stripslashes($val);
					if ($k['decimals']) {
						$out = number_format($out, $k['decimals'], '.', '');
					}
					if (!$k['no_hsc']) {
						$out = htmlspecialchars($out);
					}
				}
			break;
		}
		if ($k['wrap']) {
			$out = str_replace('|', $out, $k['wrap']);
		}
		return $out;
	}

	function __toString() {
		return __CLASS__;
	}

}

} // class exists

?>