<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Ukraine <slapidya@yahoo.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('phploadavg').'phploadavg/index.php');

class pla_factory_typo3 extends pla_factory {

	function outputHTMLHead() {
		$GLOBALS['TSFE']->additionalHeaderData[] = '
		<META HTTP-EQUIV="Page-Enter" CONTENT="BlendTrans(Duration=1)">
		<META HTTP-EQUIV="Site-Exit" CONTENT="BlendTrans(Duration=1)">
		<link rel="stylesheet" type="text/css" href="'.t3lib_extMgm::siteRelPath('phploadavg').'phploadavg/loadavg.css">';
	}

	function outputRefreshScript() {
		$content .= '
		<script>
			setTimeout(function () {
				location.href="index.php?id='.$GLOBALS['TSFE']->id.'&refresh="+Math.random();
			}, '.($this->pla->refresh_timeout * 1000).');
		</script>
		';
		print ($content);
	}

}

/**
 * Plugin 'phploadavg' for the 'phploadavg' extension.
 *
 * @author	Ukraine <slapidya@yahoo.com>
 * @package	TYPO3
 * @subpackage	tx_phploadavg
 */
class tx_phploadavg_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_phploadavg_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_phploadavg_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'phploadavg';	// The extension key.
	var $pi_checkCHash = true;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();

		ob_start();
		$pla = new pla_factory_typo3();
		$pla->main();
		$content .= ob_get_contents();
		ob_end_clean();

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/phploadavg/pi1/class.tx_phploadavg_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/phploadavg/pi1/class.tx_phploadavg_pi1.php']);
}

?>